//**************************************************************************
//			                                                                  	
//                  KNCT-MMEdu for Arduino       F{ tRP
//                                                                                                 	
//@ZbgXCb`Ńj[ID00-11܂LEDɕ\       
//  00FZT`FbNC01F\C10Fg@C11:ŒZs       
//  2010.11.28  Ver 1.0
//**************************************************************************
#include <MsTimer2.h>

#define PT_FR  0                         // EOZTCAiO
#define PT_FL  1                         // OZTCAiO
#define PT_R   2                         // EZTC@AiO
#define PT_L   3                         // ZTC@AiO
#define GYRO   4                         // WCpɗ\CAiO
#define LEDOUT 19                        // ǃZTpLEDóiAN5fW^19ƂĎgj
#define SET    2                         // ZbgXCb`CfW^
#define START  3                         // X^[gXCb`CfW^ 

// el
#define LSPD    3                       // ᑬs̃^C}[JEgl
#define HSPD    2                       // s̃^C}[JEgl
#define STEP1   650                      // PXebv̕ 
#define R90     265                      // EXOx]̕ 
#define L90     265                      // XOx]̕ 
#define R180    530                      // EPWOx]̕ 
#define DISFR   599                      // OEǂ̕W̃ZTl 
#define DISFL   625                      // Oǂ̕W̃ZTl 
#define DISR    210                       // Eǂ̕W̃ZTl 
#define DISL    200                      // ǂ̕W̃ZTl    
#define DISFMAX 60                       // Oǂ̍ő勗̃ZTl(ZTl͍ŏ) 
#define DISRMAX 80                       // Eǂ̍ő勗̃ZTl(ZTl͍ŏ) 
#define DISLMAX 80                       // ǂ̍ő勗̃ZTl(ZTl͍ŏ) 

// [^̉]p^[e[uCEƍ͋tȂ̂ŋt]
const byte RMOTOR[]={0x03, 0x06, 0x0C, 0x09, 0x00};  // E[^PORTB֏o
const byte LMOTOR[]={0x90, 0xC0, 0x60, 0x30, 0x00};  // [^PORTD֏o

const byte DtoR[]={0,2,4,0,8,0,0,0,1};   // ݂̕ɑ΂ĉE̕^e[u 
const byte DtoL[]={0,8,1,0,2,0,0,0,4};   // ݂̕ɑ΂č̕^e[u       

byte pmode=0;                            // vO[h
byte patR=0, patL=0;                     // [^̗㎥p^[̈ʑ 
byte modeR=0, modeL=0;                   // [^̉Et]̃[h  
int cntR, cntL;                          // [^̉]JEg 
int stepR, stepL;                        // [^̉]̎wpϐ  
int sensFR, sensFL, sensR, sensL;        // ZT̒l 
int sensFRB, sensFLB, sensRB, sensLB;    // LED̃ZT̒l 
byte timR=0, timL=0;                     // 荞ݓŎgR,L[^̃^C}[ 
byte timS;                               // 荞ݓŎgZT̃^C}[ 
byte fS=0;                               // xtOC̎ɕǂƂ̋␳  
byte fR=0, fL=0;                         // R,L[^̒ᑬE؂ւtO 0:ᑬC1:  

union {                                  // }bvLz̍\`  
       byte all;                         // mmapoCgPʂŃANZX  
       struct { byte n:1;                // k̕ǂ̗Li0:CPFLj  
                byte e:1;                // ̕ǂ̗Li0:CPFLj  
                byte s:1;                // ̕ǂ̗Li0:CPFLj  
                byte w:1;                // ̕ǂ̗Li0:CPFLj  
                byte d:4;                // iEjSrbgŋL̈m  
              };
        } mmap[16][16]; 

//-------------------------------------------------------------------------- 
//  LED\	                                              	 
//-------------------------------------------------------------------------- 
void dispLED(byte n)
{
 PORTB &= B11001111;                     // LEDU
 PORTB |= (n<<4);                        // LED\
}

//-------------------------------------------------------------------------- 
//  ^C}[荞ݏ	                                              	 
//-------------------------------------------------------------------------- 
void SensAndMotor(void) {    

// [^] mode = 0: t[C1: OiC2: ށC3: u[L
// E[^ 
  if (timR>0) timR--;                         // timRJEg_ECtimR=0̂Ƃ
  if (timR==0) {
    if (fR==0) timR=LSPD; else timR=HSPD;
    if (modeR==1) {if (patR < 3) patR++; else patR = 0; }
    if (modeR==2) {if (patR > 0) patR--; else patR = 3; }     
    cntR++;                                   // E[^̕JEg 
  }
// [^
  if (timL>0) timL--;                         // timLJEg_ECtimL=0̂Ƃ
  if (timL==0) {
    if (fL==0) timL=LSPD; else timL=HSPD;
    if (modeL==1) {if (patL < 3) patL++; else patL = 0; }
    if (modeL==2) {if (patL > 0) patL--; else patL = 3; }          
    cntL++;                                   // [^̕JEg 
  }
    
  if (modeR==0 || modeL==0) { patR=4; patL=4; }  // mode0̂Ƃ̓t[    
  PORTB &=0xf0; PORTB |= RMOTOR[patR];        // E[^փp^[̏o
  PORTD &=0x0f; PORTD |= LMOTOR[patL];        // [^փp^[̏o

// ZT
// LED̊lCLED_̍ŃZTlǂݎD
  if (timS<20) timS++; else timS=0;          // ZTǂݎJE^  
  if (timS==0){ 
    sensFRB=analogRead(PT_FR);               // LED̏l
    sensFLB=analogRead(PT_FL);
    sensRB=analogRead(PT_R);
    sensLB=analogRead(PT_L); 
    digitalWrite(LEDOUT, HIGH);              // LED-ON  
    delayMicroseconds(50);                   // LED̓_ɎԂ̂ŏ҂
    sensFR=analogRead(PT_FR)-sensFRB;        // LED̏l 
    sensFL=analogRead(PT_FL)-sensFLB;
    sensR =analogRead(PT_R) -sensRB;
    sensL =analogRead(PT_L) -sensLB;  
    digitalWrite(LEDOUT, LOW);               // LED-OFF
  }  

// EZTɂ鋗̕␳
// EǂƂ͉Eǂ݂̂gǖCǂ݂͍̂̎ǂ
// W̋iZTljƌ݂̍ƂC傫ɕ␳
  if (fS==1){                                   // ǂƂ̋␳ꍇCȉ̏
    fR=fL=1;                                    // E܂ݒ
    if(sensR>DISRMAX){                          // Eǂ݂ĂȂEǂ݂̂Œ  
      if ((sensR-DISR)>20) fL=0;                // Eǂɋ߂ÂC[^
      if ((sensR-DISR)<-20) fR=0;               // Eǂ牓鎞CE[^      
    } else if(sensL>DISLMAX){                   // ǂ̂ݑ݂Ăꍇ̒  
      if ((sensL-DISL)>20) fR=0;                // l͉EǂƓ  
      if ((sensL-DISL)<-20) fL=0;
    }
  } else { fR=fL=0; }                           // fS=0̎Cᑬɐݒ

}

//-------------------------------------------------------------------------- 
// ZTCZT̒lLEDɕ\		                                                                                             
//-------------------------------------------------------------------------- 
void check_sens() {  
  while (1){   
    Serial.print(0x0c,BYTE);  // y[W
    Serial.print("Sensor FR:"); Serial.println(sensFR); // EOZTlo  
    Serial.print("Sensor FL:"); Serial.println(sensFL); // OZTlo  
    Serial.print("Sensor  R:"); Serial.println(sensR);  // EZTlo  
    Serial.print("Sensor  L:"); Serial.println(sensL);  // ZTlo 
    delay (500);
  }
}

//-------------------------------------------------------------------------- 
//	u[L                        		                                     
//-------------------------------------------------------------------------- 
void run_break(){
  modeR=0; modeL=0;                     // [^~  
}

//-------------------------------------------------------------------------- 
//	Oǂɂpx         		                                           
//-------------------------------------------------------------------------- 
void adjust(){
  fS=0;                                 // ᑬ   
  while(abs((sensFR-DISFR)-(sensFL-DISFL))>20){  // OZT̒l̍傫␳
    if ((sensFR-DISFR)>(sensFL-DISFL)) { 
      modeR=2; modeL=1;                 // E^[
    } else { 
      modeR=1; modeL=2;                 // ^[
    } 
    delay(1);                           // ҂CȂƍœK̂ߏ肭Ȃ
  } 
  run_break();
}

//-------------------------------------------------------------------------- 
//	OiɒᑬŃX^[g                
//-------------------------------------------------------------------------- 
void slow_start(){
  fS=0;                                 // ŏ͒ᑬݒ
  modeR=modeL=1;                        // [hݒ E:OiCFOi  
  cntR=0; stepR=20;                     // ᑬłTOXebvi
  while (cntR<stepR) delay(1);          // w]܂ő҂D
                                        // ȂƍœKŖĂ܂̂delayĂD  
}

//-------------------------------------------------------------------------- 
//	XebvOi                
//-------------------------------------------------------------------------- 
void run_step(){
  slow_start();
  fS=1;                                 // c̋Ői
  cntR=0; stepR=STEP1-20;             
  while (cntR<stepR) delay(1);
  run_break();
}  

//-------------------------------------------------------------------------- 
//	EXOx]          		                                     
//-------------------------------------------------------------------------- 
void run_R90(){ 
  fS=0;                                 // ᑬݒ 
  cntR=0; stepR=R90;                    // E90x]̕Zbg  
  modeR=2; modeL=1;                     // E:ށCFOi   
  while (cntR<stepR) delay(1);
  run_break();
}  

//-------------------------------------------------------------------------- 
//	XOx]          		                                     
//-------------------------------------------------------------------------- 
void run_L90(){
  fS=0;                                 // ᑬݒ  
  cntL=0; stepL=L90;                    // 90x]̕Zbg  
  modeR=1; modeL=2;                     // E:OiCF  
  while (cntL<stepL) delay(1);
  modeR=0; modeL=0;
  run_break();
}  

//-------------------------------------------------------------------------- 
//	EPWOx]          		                                     
//-------------------------------------------------------------------------- 
void run_R180(){ 
  fS=0;                                 // ᑬݒ 
  cntR=0; stepR=R180;                   // E90x]̕Zbg  
  modeR=2; modeL=1;                     // E:ށCFOi   
  while (cntR<stepR) delay(1);
  run_break();
}  

//--------------------------------------------------------------------------
//	U^[܂͉E^[s,OiCǂ猸C␳^[
//--------------------------------------------------------------------------
void run_Turn(byte n){
  while (1){
    slow_start();
    fS=1;                               // c̋Ői
    while (sensFR<DISFR) delay(1);              // OiEjZTŕW܂ő点   
    adjust();                           // Oǂɂpx   
    if (n==0) run_R180(); else run_R90();   // E180x^[ ܂ EXOx^[
  }
} 

//-------------------------------------------------------------------------- 
//	g@iL^j                                                 
//  COCE̗D揇ʂŕCs~܂ȂU^[                    
//-------------------------------------------------------------------------- 
void run_Hidarite(){
  byte wF, wR, wL;               // OCECɕǂ邩ǂ̃tO  
  byte wS;                       // ǃZXsǂ̃tO  
  byte mapF, mapR, mapL;         // }bv̗ǂݏoɎgϐ 
  byte mx,my;                    // }EXx,yWC0,0CkɂCɂ  
  byte md;                       // }EX̌ĂCkFPCFQCFSCFW 
  
  mapF=0; mapR=0; mapL=0;                     // }bvǂݏoϐ̏ 
  mx=0; my=0; md=1;                           // }EX̏W0,0, k  
  wF=0; wR=1; wL=1;                           // X^[g_͑Oi  
  mmap[0][0].d=1;                              // ʒu̗kɃZbg 

  while (digitalRead(START)==HIGH){                  // {^܂ŌJԂ  

  // ̓ǂݏoimapF,mapR,mapLɑOCECj
  // CݒnŐ̂Ƃmmapz񂩂͂ݏoANZXȂD
    switch (md){
      case 1: if (my<15) mapF=mmap[my+1][mx].d; // k̂Ƃ
              if (mx<15) mapR=mmap[my][mx+1].d; 
              if (mx>0)  mapL=mmap[my][mx-1].d; 
              break;
      case 2: if (mx<15) mapF=mmap[my][mx+1].d; // ̂Ƃ
              if (my>0)  mapR=mmap[my-1][mx].d; 
              if (my<15) mapL=mmap[my+1][mx].d; 
              break;
      case 4: if (my>0)  mapF=mmap[my-1][mx].d; // ̂Ƃ
              if (mx>0)  mapR=mmap[my][mx-1].d; 
              if (mx<15) mapL=mmap[my][mx+1].d; 
              break;     
      case 8: if (mx>0)  mapF=mmap[my][mx-1].d; // ̂Ƃ
              if (my<15) mapR=mmap[my+1][mx].d; 
              if (my>0)  mapL=mmap[my-1][mx].d; 
              break;
    }
  
// 獶@̏f
    if (wL ==0 && (mapL==0 || mapL==DtoL[md]))      // ǂ,i܂͗ō܉̎ɍ  
      {run_L90(); md=DtoL[md]; }               
    else if (wF==0 && (mapF==0 || mapF==md)){}      // Oǂ,i̂ƂOi(elseifȉfʂ) 
    else if (wR==0 && (mapR==0 || mapR==DtoR[md]))
      {run_R90(); md=DtoR[md]; }                    // Eǂ,i̎E  
    else {run_R180(); md=DtoR[md]; md=DtoR[md];}    // U^[  

// CZTőO㍶E̕ǂȂOiD
    wS=0; wF=0; wR=0; wL=0;                         // ǔf̃tOZbg 
    slow_start();                                   // ᑬX^[g
    stepR=STEP1;
    fS=1;                                           // ݒ
    while (cntR<stepR){                             // PXebv񂷁D   
      if (cntR > (STEP1*2/3) && wS==0){             // 덷ɂ듮h~̂߃Xebv2/3̏ŕǌo    
        wS=1;                                       // 1xǌo邽߃tOiwSj𗧂Ă                               
        if (sensR > DISRMAX) wR=1; else wR=0;       // Eǌo   
        if (sensL > DISLMAX) wL=1; else wL=0;       // ǌo
        if ((sensFR>DISFMAX || sensFL>DISFMAX)){ wF=1; break; }  // OǌoCOǂ烋[v𔲂  
      }
      delay(1);                                     // ҂
    } 
    
    // Oǂoă[v𔲂ƂCOǂ܂Ői
    if (wF==1){                                     
      while (sensFR<DISFR) delay(1);                // ǂŋ 
      adjust();                                     // Oǂɂpx
    } 

// iE̋tjiޑO̍WɋL^D
// Ǐ̓}EX̕ɉčWXVɋL^D                                      
    switch (md){  
      case 1: mmap[my][mx].d=4; my++; mmap[my][mx].n=wF; mmap[my][mx].e=wR; mmap[my][mx].w=wL; break; 
      case 2: mmap[my][mx].d=8; mx++; mmap[my][mx].e=wF; mmap[my][mx].s=wR; mmap[my][mx].n=wL; break;
      case 4: mmap[my][mx].d=1; my--; mmap[my][mx].s=wF; mmap[my][mx].w=wR; mmap[my][mx].e=wL; break;
      case 8: mmap[my][mx].d=2; mx--; mmap[my][mx].w=wF; mmap[my][mx].n=wR; mmap[my][mx].s=wL; break;
    } 
    if (mx==0 && my==0) { run_break(); break; }           // X^[gn_ɖ߂TI  
  }
}

//-------------------------------------------------------------------------- 
//	}bvŒZ߁CŒZs                                       
//-------------------------------------------------------------------------- 
void run_saitan(){
  byte i,j,k,m;                  // ėpϐ 
  byte smap[16][16];             // ŒZ߂}bv  
  byte run[256];                 // ŒZsp^[z 
  byte md;                       // }EX̌ĂCkFPCFQCFSCFW 
    
// ŒZ}bvNACT͑SĂׂ̂ƂD
  for(i=0;i<16;i++){
    for(j=0;j<16;j++){         
      smap[i][j]=0;
      if (mmap[i][j].d==0){ 
        mmap[i][j].n=1; if (i<15) mmap[i+1][j].s=1;
        mmap[i][j].e=1; if (j<15) mmap[i][j+1].w=1;
        mmap[i][j].s=1; if (i>0)  mmap[i-1][j].n=1;
        mmap[i][j].w=1; if (j>0)  mmap[i][j-1].e=1;
      }
    }
  }

// }bv쐬
// S[ʒuɂPZbgCm̏l͂P. SXLC̈ʒuȂړ\
// Ɏ̕im+1jZbg.JԂCX^[gn_ɓB烋[v𔲂.
  
  smap[7][7]=1; smap[7][8]=1; smap[8][7]=1; smap[8][8]=1; // S[ɂPZbg
  m=1;                                                    // m̏lZbg  
  for(k=0;k<255;k++){                                     // ō255JԂ  
    for(i=0;i<16;i++){
      for(j=0;j<16;j++){                                  // SXL  
        if (smap[i][j]==m){                                 
          if (mmap[i][j].n==0 && i<15 && smap[i+1][j]==0) smap[i+1][j]=m+1;
          if (mmap[i][j].e==0 && j<15 && smap[i][j+1]==0) smap[i][j+1]=m+1;
          if (mmap[i][j].s==0 && i>0  && smap[i-1][j]==0) smap[i-1][j]=m+1;
          if (mmap[i][j].w==0 && j>0  && smap[i][j-1]==0) smap[i][j-1]=m+1;
        }
      }
    }
    m++;                                      // i߂ 
    if (smap[0][0]!=0) break;                 // X^[gn_܂ŕ𖄂߂烋[v甲  
  }
        
// }bvtɂǂrun[k] ɍŒZoH̑sp^[
// k̓p^[D1:i, 2:E܁C3:
  m=smap[0][0]-1;                             // mɃX^[gʒu̕Ctɂǂ  
  i=0; j=0; k=0;
  md=1;
  while (m>0){                                // S[܂œBCm--ꂽ_ŏI  
    switch(md){
      case 1: if (mmap[i][j].n==0 && smap[i+1][j]==m && i<15) {run[k]=1; i++; m--;    break;}
              if (mmap[i][j].e==0 && smap[i][j+1]==m && j<15) {run[k]=2; md=DtoR[md]; break;}
              if (mmap[i][j].w==0 && smap[i][j-1]==m && j>0 ) {run[k]=3; md=DtoL[md]; break;}
      case 2: if (mmap[i][j].e==0 && smap[i][j+1]==m && j<15) {run[k]=1; j++; m--;    break;}
              if (mmap[i][j].s==0 && smap[i-1][j]==m && i>0 ) {run[k]=2; md=DtoR[md]; break;}
              if (mmap[i][j].n==0 && smap[i+1][j]==m && i<15) {run[k]=3; md=DtoL[md]; break;}
      case 4: if (mmap[i][j].s==0 && smap[i-1][j]==m && i>0 ) {run[k]=1; i--; m--;    break;}
              if (mmap[i][j].w==0 && smap[i][j-1]==m && j>0 ) {run[k]=2; md=DtoR[md]; break;}
              if (mmap[i][j].e==0 && smap[i][j+1]==m && j<15) {run[k]=3; md=DtoL[md]; break;}
      case 8: if (mmap[i][j].w==0 && smap[i][j-1]==m && j>0 ) {run[k]=1; j--; m--;    break;}
              if (mmap[i][j].n==0 && smap[i+1][j]==m && i<15) {run[k]=2; md=DtoR[md]; break;}
              if (mmap[i][j].s==0 && smap[i-1][j]==m && i>0 ) {run[k]=3; md=DtoL[md]; break;}
    }
    k++;
  }
    
// ŒZoH𑖍s
  i=0;
  while (i<k){
    if (run[i]==1) { run_step(); i++; }
    if (run[i]==2) { run_R90();  i++; }
    if (run[i]==3) { run_L90();  i++; }
  }
}

//--------------------------------------------------------------------------
//		 		                                                  
//--------------------------------------------------------------------------
void setup()
{
  int i,j;

  DDRB |=B00111111;                      // PB0-4 E[^CPB5,PB6LEDL0,L1
  DDRD |=B11110000;                      // PD4-7 [^, PD1TXCPD2SET,PD3START
  pinMode(LEDOUT, OUTPUT);             // ǃZTpLEDo
  digitalWrite(LEDOUT, LOW);           // ŏLED

// }bv̏
  for (i=0; i<16;i++) for (j=0;j<16;j++) mmap[i][j].all=0;   // ܂NA
  for (i=0; i<16;i++){
     mmap[i][0].w=1; mmap[i][15].e=1;                         // ̊O̕ǂZbg 
     mmap[0][i].s=1; mmap[15][i].n=1; }                       // k̊O̕ǂZbg 
  mmap[0][0].e=1;    
 
  MsTimer2::set(1, SensAndMotor);      // ݒC1ms 
  MsTimer2::start();                    // ^C}[X^[g 
  Serial.begin(9600);                  // VA|[gJCǃZT`FbNp
}

//--------------------------------------------------------------------------
//		C[v 		                                                  
//--------------------------------------------------------------------------
void loop()
{
  while (digitalRead(START)==HIGH){
    if (digitalRead(SET)==LOW) {      // ZbgXCb`ꂽvO[hi߂
      delay(10);  // `^Oh~
      while(digitalRead(SET)==LOW);
      delay(10);  // `^Oh~
      pmode++; if (pmode>3) pmode=0;
    }
    dispLED(pmode);
  }
  dispLED(0);
  delay(500);                           // 0.5b҂

  // vOs
  switch(pmode){
/*
    case  0: run_step(); break;          // PXebvs
    case  1: run_R90();  break;          // E90x^[ 
    case  2: run_L90();  break;          // 90x^[    
    case  3: run_R180(); break;          // 180x^[       
*/    
    case  0: check_sens();   break;       // ZT`FbN   
    case  1: run_Turn(0);    break;       // U^[s
    case  2: run_Hidarite(); break;       // g@   
    case  3: run_saitan();   break;       // ŒZoH𑖍s   

  }
}




